.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include reg.inc
.data
	hPMenu			HWND 0
	RMenu1 db "Option One",0
	RMenu2 db "Option Two",0
	RMenu3 db "Option Tree",0
	RMenu4 db "Option Four",0
	RMenu5 db "Option Five",0
	RMenu6 db "Take your time to study !",0


MsgText         db "Custom Window Shapes Example",0ah
                db "Actually coded by ramguru",0ah
                db "Edited by Falcon to show how ",0ah
                db "to make custom window shapes on",0ah
                db "Child Windows",0
MsgCap          db "About",0
RsrcName        db "RANGE",0
RsrcType        db "RGN",0
RsrcHand        dd ?
RsrcSize        dd ?
RsrcPoint       dd ?
brush           dd ?

.CONST=
		IDPM_COMMAND1 equ 10
		IDPM_COMMAND2 equ 11
		IDPM_COMMAND3 equ 12
		IDPM_COMMAND4 equ 13
		IDPM_COMMAND5 equ 14
		IDPM_COMMAND6 equ 15
.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_INITDIALOG
; -->   LOAD BITMAP FROM EXECUTABLE (RESOURCE)
        invoke  LoadBitmap,hInstance,20000                   
        
; -->   USE THAT BITMAP AS WINDOW BACKGROUND            
        invoke  CreatePatternBrush,eax
        mov     brush, eax
; -->   LOAD REGION_DATA (SEE API REF FOR QUESTIONS)
        invoke  FindResource,hInstance,addr RsrcName,addr RsrcType
        mov     RsrcHand, eax

        invoke  LoadResource,hInstance,eax
        mov     RsrcPoint, eax

        invoke  SizeofResource,hInstance,RsrcHand
        mov     RsrcSize, eax

        invoke  LockResource,RsrcPoint
        mov     RsrcPoint, eax          

; -->   CREATE REGION AND PASS IT TO OUR WINDOW 
        invoke  ExtCreateRegion,NULL,RsrcSize,eax
        invoke  SetWindowRgn,hWin,eax,TRUE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		invoke CreatePopupMenu
		mov hPMenu,eax
		invoke PMenu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	.elseif uMsg==WM_CTLCOLORDLG
		mov eax, brush
		ret
		
	.elseif uMsg == WM_COMMAND

		.elseif wParam == 1002
            Invoke MessageBox, hWin, addr MsgText, addr MsgCap, MB_OK+MB_ICONINFORMATION
            .elseif wParam == 1003
		Invoke PostQuitMessage,NULL
		.endif
	.elseif uMsg==WM_CONTEXTMENU
				
				invoke GetCursorPos,addr p
				invoke TrackPopupMenu,hPMenu,TPM_RIGHTBUTTON,p.x,p.y,0,hWin,0
				invoke GetLastError
      .elseif uMsg==WM_LBUTTONDOWN
		invoke SendMessage,hWin,WM_NCLBUTTONDOWN,HTCAPTION,lParam	
	
      .elseif uMsg == WM_DESTROY
            Invoke DeleteObject, brush
      .elseif uMsg==WM_CLOSE
		invoke PostQuitMessage, 0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret

DlgProc endp

PMenu Proc
				
			invoke AppendMenu,hPMenu,MF_STRING,IDPM_COMMAND1,ADDR RMenu1
			invoke AppendMenu,hPMenu,MF_SEPARATOR,0,0
			invoke AppendMenu,hPMenu,MF_STRING,IDPM_COMMAND2,ADDR RMenu2
			invoke AppendMenu,hPMenu,MF_STRING,IDPM_COMMAND3,ADDR RMenu3
			invoke AppendMenu,hPMenu,MF_STRING,IDPM_COMMAND4,ADDR RMenu4
			invoke AppendMenu,hPMenu,MF_STRING,IDPM_COMMAND5,ADDR RMenu5
			invoke AppendMenu,hPMenu,MF_SEPARATOR,0,0
			invoke AppendMenu,hPMenu,MF_STRING,IDPM_COMMAND6,ADDR RMenu6
			invoke EnableMenuItem,hPMenu,IDPM_COMMAND2,MF_GRAYED
			invoke CheckMenuItem,hPMenu,IDPM_COMMAND6,MF_CHECKED
		
 	ret
PMenu ENDP


end start
